{************************************************************************}
{************************************************************************}
{* Modul:       adinfo.pas                                              *}
{************************************************************************}
{* Inhalt:      Extraktion von Zusatzinformationen fr ADir             *}
{************************************************************************}
{* Funktion:    Extraktion der Horizontal-, Vertikal- und Farb-Auflsung*}
{*              sowie Paletten- und Pack-Informationen fr Bilder,      *}
{*              Titel, Instrumentenzahl und Lnge fr Musik, Titel und  *}
{*              Betriebssystem fr Programme, Anzahl und Kompressions-  *}
{*              grad fr gepackte Archive.                              *}
{************************************************************************}
{* Version:     0.58e                                                   *}
{* Autor:       Thomas Mainka                                           *}
{* Datum:       14.Nov.1996                                             *}
{* Vernderung: Korrektur der HTML-Erkennung.                           *}
{*              Erweiterung der PIF-Dateien um NT- und W9x-PIF.         *}
{*              Aufnahme von OS/2-Messages.                             *}
{************************************************************************}
{* Revision:    0.10 Erste Public Beta-Version                          *}
{*               :                                                      *}
{*               :   siehe Anhang C (Adir_Doc.xxx)                      *}
{*               :                                                      *}
{*              0.50 Erweiterung des Plain Text-Formats um die Erkennung*}
{*                   von Postscript- u. RTF-Dateien.                    *}
{*                   Korrektur des ZOO-Formats (Datei-Ende-Erkennung)   *}
{*                   Korrektur des SQZ-Formats (Datei-Ende-Erkennung)   *}
{*                   Erweiterung des AVI-Formats um bessere Codec-      *}
{*                   Erkennung.                                         *}
{*              0.52 Aufnahme von RDIB-Bildern.                         *}
{*                   Aufnahme von FLC-Animationen                       *}
{*                   Aufnahme von BOSS-EXE (Borland DOS-Erweitrung)     *}
{*                   Erweiterung von RTF-, PS- und Word-Dateien um Titel*}
{*                   Umwandlung von Windows-Namen in OEM-Strings.       *}
{*                   Test auf Untersttzung langer Dateinamen bei       *}
{*                   OS/2 EXE.                                          *}
{*                   Erweiterung der WKS um Quattro Pro 5.x WQ2.        *}
{*              0.54 Aufnahme von RAR-Archiven.                         *}
{*                   Aufnahme von PBM-Bilder (Erw. der ILBM-Routine).   *}
{*                   berarbeitung der Tiff-Routine zur besseren Erfas- *}
{*                   sung von Truecolor-Bildern und weiteren Kompress-  *}
{*                   sionsverfahren                                     *}
{*                   Korrektur der WPG-II Graphiken (Word Perfekt 5.1). *}
{*                   Erweiterung der Targa-Bilder um Paletten und Pack- *}
{*                   Information.                                       *}
{*              0.54a Aufnahme von Win-NT-Applikationen im COFF-Format  *}
{*                    (Erweiterung der EXE-Routine).                    *}
{*              0.56 Aufnahme von TTF, PFB und PFM-Fontdateien.         *}
{*                   Aufnahme von WinWord 1.x und 2.x Dokumenten.       *}
{*                   Aufnahme von TP bzw BP-TPUs.                       *}
{*                   Korrektur des SQZ-Archiv-Formates.                 *}
{*              0.56a Neustrukturierung der DateiTypKlassen.            *}
{*                    Ermittelung von der lngeren Titel-Strings fr    *}
{*                    eine breitere Ausgabe bei passendem Schirm bzw.   *}
{*                    FILES.BBS.                                        *}
{*              0.56b Aufnahme von animierten Icons (Win-NT).           *}
{*                    Extraktion von Titeln aus WAV-Dateien.            *}
{*                    Aufnahme von 669- und S3M-Soundmodulen.           *}
{*              0.58 Korrektur der IO-Fehlerverwaltung bei defekten     *}
{*                   Dateien.                                           *}
{*                   Korrektur d.Instrumentenzahl bei alten CMF-Dateien.*}
{*                   Neuer DateiTyp: Grasp-GL-Animationen als "Archive".*}
{*              0.58a Erweiterung des VOC-Dateiformats um V1.20 VOC-    *}
{*                    Dateien und Korrektur der Spieldauer bei Stereo-  *}
{*                    Sounds.                                           *}
{*                    Erweiterung des OS/2-HLP Dateiformats um -INF-Dat.*}
{*                    Aufnahme von PNG-Bildern.                         *}
{*              0.58b Erweiterung der W386-Dateien um Versionsnummer.   *}
{*                    Erweiterung der IFF/8SVX-Sounds um Spieldauer.    *}
{*                    Anpassung d. RAR-Archive auf Version >= 1.50      *}
{*                    Aufnahme von Intel-OBJ-Dateien.                   *}
{*                    Aufnahme von Fido-PKT-Pakete.                     *}
{*              0.58c Korrektur der Lngenbest. bei korrupten WAV-Dat.  *}
{*                    Erweiterung der COFF-EXE um Titelangabe.          *}
{*                    Erweiterung der DOS-Device-Treiber um NDIS-Treiber*}
{*                    Aufnahme von QuickTime-MOV-Dateien.               *}
{*              0.58d Erweiterung des AVI-Formats um Farbtiefe.         *}
{*                    Aufnahme von IFF/AIFF-Sounds.                     *}
{*                    Aufnahme von Sun/Next-AU-Sounds.                  *}
{*                    Aufnahme von HTML-Hypertext-Dateien.              *}
{*                    Aufnahme von 4DOS-BTM-Dateien.                    *}
{*                    Aufnahme von Fido-MSG-Dateien.                    *}
{*                    Aufnahme von D64- u. T64-Dateien d. C64-Emulators *}
{************************************************************************}
{* Routinen:    LongI                                                   *}
{*              Long3                                                   *}
{*              FWord                                                   *}
{*              SFWord                                                  *}
{*              TitStr                                                  *}
{*              BFCompare                                               *}
{*              CFCompare                                               *}
{*              InfoRiff                                                *}
{*              IniGraph        (Ad_Graph.Inc)                          *}
{*              PcxInfo         (Ad_Graph.Inc)                          *}
{*              DcxInfo         (Ad_Graph.Inc)                          *}
{*              BmpTest         (Ad_Graph.Inc)                          *}
{*              BmpInfo         (Ad_Graph.Inc)                          *}
{*              RDibInfo        (Ad_Graph.Inc)                          *}
{*              RleInfo         (Ad_Graph.Inc)                          *}
{*              WpgInfo         (Ad_Graph.Inc)                          *}
{*              MspInfo         (Ad_Graph.Inc)                          *}
{*              IcoInfo         (Ad_Graph.Inc)                          *}
{*              SciInfo         (Ad_Graph.Inc)                          *}
{*              FliInfo         (Ad_Graph.Inc)                          *}
{*              PicInfo         (Ad_Graph.Inc)                          *}
{*              TgaInfo         (Ad_Graph.Inc)                          *}
{*              RasInfo         (Ad_Graph.Inc)                          *}
{*              TiffInfo        (Ad_Graph.Inc)                          *}
{*              CutInfo         (Ad_Graph.Inc)                          *}
{*              JpgInfo         (Ad_Graph.Inc)                          *}
{*              GifInfo         (Ad_Graph.Inc)                          *}
{*              LbmInfo         (Ad_Graph.Inc)                          *}
{*              ImgInfo         (Ad_Graph.Inc)                          *}
{*              MacInfo         (Ad_Graph.Inc)                          *}
{*              AviInfo         (Ad_Graph.Inc)                          *}
{*              MovInfo         (Ad_Graph.Inc)                          *}
{*              PngInfo         (Ad_Graph.Inc)                          *}
{*              DbfInfo                                                 *}
{*              WksInfo                                                 *}
{*              DevTest         (Ad_Appli.Inc)                          *}
{*              SearchCoffVers  (Ad_Appli.Inc)                          *}
{*              ExeInfo         (Ad_Appli.Inc)                          *}
{*              ComInfo         (Ad_Appli.Inc)                          *}
{*              PifInfo         (Ad_Appli.Inc)                          *}
{*              NlmInfo         (Ad_Appli.Inc)                          *}
{*              VapInfo         (Ad_Appli.Inc)                          *}
{*              DevInfo         (Ad_Appli.Inc)                          *}
{*              GroupInfo       (Ad_Appli.Inc)                          *}
{*              TpuInfo         (Ad_Appli.Inc)                          *}
{*              TTFInfo         (Ad_Appli.Inc)                          *}
{*              PfbInfo         (Ad_Appli.Inc)                          *}
{*              PfmInfo         (Ad_Appli.Inc)                          *}
{*              CmfInfo                                                 *}
{*              CmsInfo                                                 *}
{*              OrgInfo                                                 *}
{*              ModInfo                                                 *}
{*              RolInfo                                                 *}
{*              WavInfo                                                 *}
{*              VocInfo                                                 *}
{*              SndInfo                                                 *}
{*              AUInfo                                                  *}
{*              MidiInfo                                                *}
{*              ArjInfo                                                 *}
{*              ArcInfo                                                 *}
{*              ZipInfo                                                 *}
{*              LzhInfo                                                 *}
{*              ZooInfo                                                 *}
{*              SqzInfo                                                 *}
{*              RarInfo                                                 *}
{*              GLInfo                                                  *}
{*              T64Info                                                 *}
{*              D64Info                                                 *}
{*              PTextInfo                                               *}
{*              BtmInfo                                                 *}
{*              MsgInfo                                                 *}
{*              PktInfo                                                 *}
{*              WordInfo                                                *}
{*              HelpInfo                                                *}
{*              GetInfo         (global)                                *}
{************************************************************************}

unit ADInfo;
{$I-,S-}
{$M 8192,8192,655360}
interface
uses dos,adsort,adstring,nls;
{$I adinfo.inc}

Var      Pause     : Boolean;
	 F,F1      : File;
	 D         : DirStr;
	 FBuf      : FBufType;

Procedure GetInfo;

implementation

Var      Test      : Word;

Function LongI(x:Byte4):Longint;
begin
   LongI:=x[4]+Word(x[3])*256+x[2]*65536+x[1]*16777216;
end;

Function Long3(x:Byte3):Longint;
begin
   Long3:=x[1]+Word(x[2])*256+x[3]*65536;
end;

Function FWord(x:Word):Word;
begin
   FWord:=FBuf.DummyA[x]+Word(FBuf.DummyA[x+1])*256;
end;

Function SFWord(x:Word):Word;
begin
   SFWord:=FBuf.DummyA[x+1]+Word(FBuf.DummyA[x])*256;
end;

Function TitStr(S:TString):TString;
Var      HStr      : TString;
	 i         : Byte;
begin
   i:=Pos(Chr(0),S);
   if (((i>20) or (i=0)) and not WideText) then i:=21;
   if i>0 then HStr:=Copy(S,1,i-1)
   else HStr:=S;
   if (WideText) then i:=32
   else i:=20;
   while Length(HStr) < i do HStr:=HStr+' ';
   TitStr:=HStr;
end;

Function BFCompare(X,Y:BArrayPtr;n:Byte):Boolean;
Var      i         : Byte;
	 P         : Boolean;
begin
   P:=True;
   for i:=0 to n do
     if x^[i]<>Y^[i] then P:=False;
   BFCompare:=P;
end;

Function CFCompare(X:CArrayPtr;Y:String):Boolean;
Var      i         : Byte;
	 P         : Boolean;
begin
   P:=True;
   for i:=1 to Length(Y) do
     if x^[i-1]<>Y[i] then P:=False;
   CFCompare:=P;
end;

Function UFCompare(X:CArrayPtr;Y:String):Boolean;
Var      i         : Byte;
	 P         : Boolean;
begin
   P:=True;
   for i:=1 to Length(Y) do
     if UpCase(x^[i-1])<>Y[i] then P:=False;
   UFCompare:=P;
end;

{************************************************************************}
{* Routine:     InfoRiff                                                *}
{************************************************************************}
{* Inhalt:      Auswertung der RIFF INFO-LIST-Chunks                    *}
{* Definition:  Procedure InfoRiff(Adr,Len1:Longint)                    *}
{************************************************************************}

Function InfoRiff(Adr,Len1:LongInt):String;
Var      Adr1      : LongInt;
	 Pos       : Word;
	 HStr      : String;

begin
   Adr1:=12;
   HStr:='';
   while Adr1<Len1 do begin
     Seek(F1,Adr+Adr1);
     Blockread(F1,FBuf.DummyA,256,Test);
     if (FBuf.RifTag = 'INAM') then begin
       Pos:=8;
       while FBuf.DummyA[Pos]<>0 do begin
	 HStr:=HStr+FBuf.Dummy0[Pos];
	 inc(Pos);
       end;
     end;
     Adr1:=Adr1+8+FBuf.RifLen;
   end;
   InfoRiff:=HStr;
end;

{$I AD_graph.inc}

{************************************************************************}
{* Routine:     DbfInfo                                                 *}
{************************************************************************}
{* Inhalt:      Identifikation von dBase-DBF und Extraktion von DLen    *}
{*              und DSat                                                *}
{* Definition:  Procedure DbfInfo;                                      *}
{************************************************************************}

Procedure DbfInfo;
begin
   if ((FBuf.DbfKen and $03) = $03) then
     with Dir[Count]^ do begin
       FTyp:=16;
       Kurz:='DBF ';
       if (FBuf.DbfHSi > 256) then 
	 if (FBuf.DbfHSi < 2048) then 
	   BlockRead(F1,FBuf.DummyB,FBuf.DbfHSi-256,Test)
	 else Blockread(F1,FBuf.DummyB,1792,Test);
       DLen:=0;
       Test:=32;
       while ((Test<FBuf.DbfHSi) and (FBuf.DbfFld[Test]<>$0d) 
	and (Test<2048)) do begin
	 Inc(DLen);
	 Inc(Test,32);
       end;
       DSat:=FBuf.DbfSat;
     end;
end;

{$I AD_Appli.Inc}

{************************************************************************}
{* Routine:     WksInfo                                                 *}
{************************************************************************}
{* Inhalt:      Identifikation von Lotus-WKS und Extraktion von DLen    *}
{*              und DSat                                                *}
{* Definition:  Procedure WksInfo;                                      *}
{************************************************************************}

Procedure WksInfo;
begin
   if (FWord(0) = $0000) then
     with Dir[Count]^ do begin
       Test:=0;
       FTyp:=17;
       Kurz:='WKS ';
       if FBuf.DummyA[4] = $04 then Kurz[4]:='1';
       if FBuf.DummyA[4] = $05 then Kurz[4]:='S';
       if FBuf.DummyA[4] = $06 then Kurz[4]:='2';
       if FBuf.DummyA[4] = $20 then Kurz[4]:='Q';
       if FBuf.DummyA[4] = $21 then Kurz[4]:='q';
       while ((FBuf.DummyA[Test]<>6) and (Test<256)) do 
	 Test:=Test+4+FWord(Test+2);
       if (FBuf.DummyA[Test]=6) then begin
	 DLen:=FWord(Test+4);
	 if DLen=-1 then DLen:=0;
	 DLen:=FWord(Test+8)-DLen+1;
	 DSat:=FWord(Test+6);
	 if DSat=-1 then DSat:=0;
	 DSat:=FWord(Test+10)-DSat+1;
       end;
     end;
end;

{************************************************************************}
{* Routine:     CmfInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von STit und SIns fr SB-CMFs                *}
{* Definition:  Procedure CmfInfo;                                      *}
{************************************************************************}

Procedure CmfInfo;
Var      i       : Word;
begin
   if (FBuf.CmfFId='CTMF') then
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='CMF ';
       STit:='';
       if (FBuf.CmfOMT <> 0) then begin
	 i:=FBuf.CmfOMT;
	 while (i<FBuf.CmfOMT+32) do begin
	   STit:=STit+FBuf.CmfDum[i];
	   i:=succ(i);
	 end;
       STit:=TitStr(STit);
       end;
       SIns:=FBuf.CmfNIn;
       if (FBuf.CmfVLo = 0) then begin
	 Kurz[4]:='o';
	 SIns:=SIns mod 256;
       end;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:     CmsInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von STit fr Gameblaster CMSs                *}
{* Definition:  Procedure CmsInfo;                                      *}
{************************************************************************}

Procedure CmsInfo;
Var      i       : Word;
begin
   if ((FBuf.Dummy0[0]='C') and (FBuf.Dummy0[1]='M')) then
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='CMS ';
       STit:='';
       SIns:=0;
       SLen:=0;
       for i:=2 to 13 do
	 if FBuf.DummyA[i] <> $0 then Inc(SIns);
       for i:=32 to 63 do
	 STit:=STit+FBuf.Dummy0[i];
       STit:=TitStr(STit);
     end;
end;

{************************************************************************}
{* Routine:     OrgInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von STit und SIns fr Intelligent-Organ-ORGs *}
{* Definition:  Procedure OrgInfo;                                      *}
{************************************************************************}

Procedure OrgInfo;
Var      i       : Word;
begin
   if ((FBuf.Dummy0[0]='C') and (FBuf.Dummy0[1]='M')) then
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='COrg';
       STit:='';
       for i:=32 to 63 do
	 STit:=STit+FBuf.Dummy0[i];
       STit:=TitStr(STit);
       SIns:=4;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:     ModInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von STit, SIns und SLen fr Amiga-MODs       *}
{* Definition:  Procedure ModInfo;                                      *}
{************************************************************************}

Procedure ModInfo;
Var      i         : Integer;
begin
   if (FBuf.ExeKen=$5A4D) then ExeInfo
   else 
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='MOD ';
       STit:=TitStr(FBuf.ModTit);
       Seek(f1,$3b6);
       Blockread(F1,FBuf.DummyB,140,i);
       if ((FBuf.ModKen='M.K.') or (FBuf.ModKen='FLT4')) then SIns:=31
       else begin
	 SIns:=15;
	 Seek(f1,$1d6);
	 Blockread(F1,FBuf.DummyB,140,i);
       end;
       if (FBuf.ModTEf mod 16)=15 then SLen:=FBuf.ModTPa
       else SLen:=6;
       SLen:=Round(1.25*FBuf.ModPat*SLen);
     end;
end;

{************************************************************************}
{* Routine:     G69Info                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von STit, SIns und SLen fr 669-Module       *}
{* Definition:  Procedure G69Info;                                      *}
{************************************************************************}

Procedure G69Info;
begin
   if ((FBuf.G69Ken='if') or (FBuf.G69Ken='JN')) then 
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='669 ';
       if FBuf.G69Ken='JN' then Kurz[4]:='E';
       STit:=TitStr(Copy(FBuf.G69Tit,1,32));
       SIns:=FBuf.G69Sam;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:     S3MInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von STit, SIns und SLen fr S3M-Module       *}
{* Definition:  Procedure S3MInfo;                                      *}
{************************************************************************}

Procedure S3MInfo;
begin
   if (FBuf.S3MAKe='SCRM') then 
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='S3M ';
       STit:=TitStr(FBuf.S3MTit);
       SIns:=FBuf.S3MSam;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:     RolInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von SIns fr Adlib-ROLs                      *}
{* Definition:  Procedure RolInfo;                                      *}
{************************************************************************}

Procedure RolInfo;
Type     RolFNot   = record
		       Note   : Integer;
		       Dura   : Integer;
		     end;
	 RolEvnt   = record
		       Filler : Array[1..15] of Byte;
		       NumEvt : Integer;
		     end;
	 RolIEvn   = record
		       TimTic : Integer;
		       InsNam : Array[1..9] of Char;
		       Reser1 : Char;
		       Reser2 : Integer;
		     end;
Var      LastI     : Integer;
	 Flg       : Boolean;
	 RFNot     : RolFNot;
	 REvnt     : RolEvnt;
	 RIEvn     : RolIEvn;
	 INamen    : Array[0..100] of String[9];
	 Voice     : Integer;
	 i,j       : Integer;

begin
   if ((FBuf.RolVHi < 2) and (FBuf.RolVLo < 20)) then
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='ROL ';
       STit:='';
       LastI:=0;
       Seek(f1,203+(6*FBuf.RolTEv));
       for Voice:=0 to 10 do begin
	 BlockRead(f1,REvnt,17);
	 while REvnt.NumEvt > 0 do begin
	   BlockRead(f1,RFNot,4);
	   REvnt.NumEvt:=REvnt.NumEvt - RFNot.Dura;
	 end;
	 BlockRead(f1,REvnt,17);
	 for i:=1 to REvnt.NumEvt do begin
	   BlockRead(f1,RIEvn,14);
	   j:=0;
	   Flg:=True;
	   INamen[LastI]:=RIEvn.InsNam;
	   Delete(INamen[LastI],Pos(Char(0),INamen[LastI]),9);
	   while ((j < LastI) and Flg) do begin
	     if INamen[j]=INamen[LastI] then Flg:=False;
	     j:=Succ(j);
	   end;
	   if Flg then LastI:=Succ(LastI);
	 end;
	 BlockRead(f1,REvnt,17);
	 Seek(f1,FilePos(f1)+(6*REvnt.NumEvt));
	 BlockRead(f1,REvnt,17);
	 Seek(f1,FilePos(f1)+(6*REvnt.NumEvt));
       end;
       SIns:=LastI;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:     WavInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von SIns und SLen fr MS-WAVs                *}
{* Definition:  Procedure WavInfo;                                      *}
{************************************************************************}

Procedure WavInfo;
Var      Adr,Len   : LongInt;
	 Len1      : LongInt;
	 SSam      : Word;
begin
   if ((FBuf.RifTag='RIFF') and (FBuf.RifTyp='WAVE')) then
     with Dir[Count]^ do begin
       STit:='';
       Adr:=12;
       Len:=FBuf.RifLen;
       while Adr<Len do begin
	 Seek(F1,Adr);
	 Blockread(F1,FBuf.DummyA,256,Test);
	 Len1:=FBuf.RifLen;
	 if (FBuf.RifTag = 'fmt ') then begin
	   FTyp:=9;
	   Kurz:='WAVE';
	   SIns:=FBuf.WavCha;
	   SSam:=FBuf.WavMSp;
	   if (SSam = 0) then begin
	     SSam:=FBuf.WavSpS;
	     Kurz[4]:='*';
	   end;
	 end;
	 if (FBuf.RifTag = 'data') then begin
	   SLen:=-Round(FBuf.RifLen*10.0/SSam);
	 end;
	 if (FBuf.RifTag = 'LIST') and (FBuf.RifTyp = 'INFO') then
	   STit:=InfoRiff(Adr,Len1);
	 Adr:=Adr+Len1+8;
       end;
       STit:=TitStr(STit);
     end;
end;

{************************************************************************}
{* Routine:     VocInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von SIns und SLen fr SB-VOCs                *}
{* Definition:  Procedure VocInfo;                                      *}
{************************************************************************}

Procedure VocInfo;
Var      Adr,Spd   : Longint;
	 Spd2      : Longint;
	 MaxAdr    : Longint;
	 Len       : Word;
	 Fak,Rep,CF: Word;
	 NewT      : Boolean;
begin
   if (FBuf.VocHea='Creative Voice File') then
     with Dir[Count]^ do begin
       NewT:=False;
       FTyp:=9;
       Kurz:='VOC ';
       SIns:=1;
       STit:='';
       Len:=0;
       Fak:=1;
       Rep:=1;
       CF:=1;
       if (FBuf.VocVer = $0114) then Kurz[4]:='2';
       MaxAdr:=FileSize(F1);
       Adr:=FBuf.VocOfs;
       Seek(F1,Adr);
       BlockRead(F1,FBuf.DummyB,64,Test);
       if (FBuf.VocTyp > 10) then begin
	 Adr:=Adr mod 256;
	 Seek(F1,Adr);
	 BlockRead(F1,FBuf.DummyB,64,Test);
       end;
       while ((FBuf.VocTyp<>0) and (FBuf.VocTyp<20)) and 
	      (Adr<=MaxAdr) do begin
	 case (FBuf.VocTyp) of
	   1: begin
		if (FBuf.VocDum[5]<3) then Fak:=FBuf.VocDum[5]+1;
		if NewT then Spd:=Spd2
		else Spd:=Round(1000000/(256-FBuf.VocDum[4]));
		Len:=Len+Round(100*Fak*Rep*Long3(FBuf.VocLen)/(Spd*CF));
	      end;
	   2: Len:=Len+Round(100*Fak*Rep*Long3(FBuf.VocLen)/Spd);
	   3: begin
		Spd:=Round(1000000/(256-FBuf.VocDum[6]));
		Len:=Len+Round(100*Rep*(FBuf.VocDum[4]+FBuf.VocDum[5]*256)/Spd);
	      end;
	   5: begin
		Test:=4;
		while ((Length(STit)<32) and (FBuf.VocDum[Test]<>0)) do begin
		  STit:=STit+Chr(FBuf.VocDum[Test]);
		  Inc(Test);
		end;
	      end;
	   6: Rep:=FBuf.VocDum[4]+FBuf.VocDum[5]*256;
	   7: Rep:=1;
	   8: begin
		NewT:=True;
		SIns:=FBuf.VocDum[7]+1;
		CF  :=SIns;
		Spd2:=(65536-(FBuf.VocDum[4]+Word(FBuf.VocDum[5])*256))*SIns;
		Spd2:=Round(256000000/Spd2);
	      end;
	   9: begin
		case (FBuf.VocDum[10]+FBuf.VocDum[11]*256) of
		  0 : Fak:=1;
		  1 : Fak:=2;
		  2 : Fak:=3;
		  3 : Fak:=4;
		  4 : Fak:=1;
		512 : Fak:=4;
		end;
		SIns:=FBuf.VocDum[9];
		CF  :=SIns * (FBuf.VocDum[8] div 8);
		Spd :=FBuf.VocDum[4]+Word(FBuf.VocDum[5])*256;
		Len:=Len+Round(100*Fak*Rep*Long3(FBuf.VocLen)/(Spd*CF));
	     end;
	 end;
	 Adr:=Adr+4+Long3(FBuf.VocLen);
	 Seek(F1,Adr);
	 BlockRead(F1,FBuf.DummyB,64,Test);
       end;
       STit:=TitStr(STit);
       SLen:=-Round(Len/10);
     end;
end;

{************************************************************************}
{* Routine:     SndInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von STit fr IFF-8SVX und MAC-FSSs           *}
{* Definition:  Procedure SndInfo;                                      *}
{************************************************************************}

Procedure SndInfo;
Var      IffVar    : IffType;
	 Adr,i     : LongInt;
begin
   with Dir[Count]^ do begin
     if (FBuf.SVXIff='FORM') then begin  
       FTyp:=9;
       Kurz:=FBuf.SvxTyp;    {'8SVX'}
       STit:='';
       SIns:=1;
       SLen:=0;
       if Kurz='8SVX' then begin
	 i:=(SFWord(20)*65536+SFWord(22) + SFWord(24)*65536+SFWord(26));
	 SLen:=-Round(i*10.0/SFWord(32));
       end;
       if Kurz='AIFF' then begin
	 SIns:=SFWord(20);
	 i:=SFWord(22)*65536 + SFWord(24);
	 if (FBuf.DummyA[28]=$40) then 
	   SLen:=-Round(i*10*(1 shl (14-FBuf.DummyA[29]))/SFWord(30));
       end;
       Adr:=LongI(FBuf.SvxHLe)+$14;
       IffVar.Typ[1]:=' ';
       while ((Adr<256) and (IffVar.Typ<>'BODY')) do begin
	 move(FBuf.SvxDum[Adr],IffVar,40);
	 if (IffVar.Typ='NAME') then begin
	   STit:=TitStr(IffVar.Par);
	   Adr:=2000;
	 end;
	 Adr:=Adr+LongI(IffVar.Len)+8;
       end;
     end
     else if ((FBuf.MacTyp='FSSDJOSH') or (FBuf.MacTyp='FSSDSFX!')) then
       begin
	 FTyp:=9;
	 Kurz:='MACS';
	 STit:=TitStr(Copy(FBuf.MacTit,1,32));
	 SIns:=1;
	 SLen:=0;
       end;
   end;
end;

{************************************************************************}
{* Routine:     AUInfo                                                  *}
{************************************************************************}
{* Inhalt:      Extraktion von SIns und SLen fr Sun/Next AU-Sound      *}
{* Definition:  Procedure AUInfo;                                       *}
{************************************************************************}

Procedure AUInfo;
Var      i,j       : Longint;
begin
   if (FBuf.DumCh4='.snd') then
     with Dir[Count]^ do begin
       FTyp:=9;
       Kurz:='AU  ';
       STit:='';
       SIns:=SFWord(22);
       i:=SFWord(10) + SFWord( 8)*65536;
       j:=SFWord(18) + SFWord(16)*65536;
       if SFWord(14)=3 then begin
	 j:=j*2;
	 Kurz:='AU16';
       end;
       SLen:=-Round(i*10/(j*SIns));
     end;
end;

{************************************************************************}
{* Routine:     MidiInfo                                                *}
{************************************************************************}
{* Inhalt:      Erkennung von Midi-Dateien                              *}
{* Definition:  Procedure MidiInfo;                                     *}
{************************************************************************}

Procedure MidiInfo;
Var      MidVar    : MidType;
	 Adr,Adr1  : LongInt;
begin
   if (FBuf.MidKen='MThd') then
     with Dir[Count]^ do begin
       FTyp:=8;
       Kurz:='MIDI';
       STit:='';
       SIns:=0;
       Adr:=LongI(FBuf.MidHLe)+8;
       while (Adr<FileSize(F1)) do begin
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,256,Test);
	 Inc(SIns);
	 Adr:=Adr+LongI(FBuf.MidHLe)+8;
	 if SIns=1 then begin
	   Adr1:=8;
	   while (Adr1<220) do begin
	     move(FBuf.MidDum[Adr1],MidVar,24);
	     if ((MidVar.Typ=$03) and (MidVar.Evt=$ff00)) then begin
	       STit:=TitStr(MidVar.Stg);
	       Adr1:=2000;
	     end;
	     Adr1:=Adr1+MidVar.Len+4;
	   end;
	 end;
       end;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:     ArjInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr ARJs                   *}
{* Definition:  Procedure ArjInfo;                                      *}
{************************************************************************}

Procedure ArjInfo;
Var      GeSi,CoSi : Longint;
	 Adr       : Longint;
	 Anz,XSi   : Word;
begin
   if (FBuf.ArjKen=$EA60) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (FBuf.ArjHSi <> 0) do begin
	 if FBuf.ArjHSi>244 then
	   Blockread(F1,FBuf.DummyB,FBuf.ArjHSi-240,Test);
	 if FBuf.ArjTyp = 2 then Adr:=Adr+FBuf.ArjHSi+10
	 else Adr:=Adr+FBuf.ArjHSi+10+FBuf.ArjCSi;
	 XSi:=FBuf.ArjHSi+8;
	 XSi:=FBuf.ArjDum[XSi]+FBuf.ArjDum[XSi+1]*256;
	 if XSi<>0 then Adr:=Adr+XSi+4;
	 if FBuf.ArjTyp < 2 then begin
	   GeSi:=GeSi+FBuf.ArjUSi;
	   CoSi:=CoSi+FBuf.ArjCSi;
	   Inc(Anz);
	 end;
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,256,Test);
       end;
       FTyp:=24;
       Kurz:='ARJ ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:='';
     end;
end;

{************************************************************************}
{* Routine:     ArcInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr ARCs und PAKs          *}
{* Definition:  Procedure ArcInfo;                                      *}
{************************************************************************}

Procedure ArcInfo;
Const    MetStr    : Array[0..11] of TString=
		     ('EOF-Tag   ','Stored old','Stored    ','Packed    ',
		      'Squeezed  ','crunched o','crunched  ','crunched S',
		      'Crunched  ','Squashed  ','Crushed   ','Distilled ');
Var      GeSi,CoSi : Longint;
	 Adr       : Longint;
	 Anz,Met   : Word;

begin
   if (FBuf.ArcKen=$1a) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       Met:=0;
       while ((FBuf.ArcKen=$1a) and (FBuf.ArcTyp<>0)) do begin
	 Adr:=Adr+FBuf.ArcCSi+29;
	 GeSi:=GeSi+FBuf.ArcUSi;
	 CoSi:=CoSi+FBuf.ArcCSi;
	 Inc(Anz);
	 if Met < FBuf.ArcTyp then Met:=FBuf.ArcTyp;
	 Seek(F1,Adr);
	 BlockRead(F1,FBuf,64,Test);
       end;
       FTyp:=24;
       if FBuf.ArcTyp <> 11 then Kurz:='ARC '
       else Kurz:='PAK ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:=MetStr[Met];
     end;
end;

{************************************************************************}
{* Routine:     ZipInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr ZIPs                   *}
{* Definition:  Procedure ZipInfo;                                      *}
{************************************************************************}

Procedure ZipInfo;
Const    MetStr    : Array[0..11] of TString=
		     ('Stored    ','Shrinked  ','Reduced 1x','Reduced 2x',
		      'Reduced 3x','Reduced 4x','Imploded  ','Token     ',
		      'Deflated  ','Method 09 ','Method 10 ','Method 11 ');
Var      GeSi,CoSi : Longint;
	 Adr       : Longint;
	 Anz,Met   : Word;

begin
   if ((FBuf.ZipKen=$4b50) and (FBuf.ZipTyp=$0403)) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       Met:=0;
       while (FBuf.ZipTyp=$0403) do begin
	 Adr:=Adr+FBuf.ZilCSi+FBuf.ZilNSi+FBuf.ZilESi+30;
	 GeSi:=GeSi+FBuf.ZilUSi;
	 CoSi:=CoSi+FBuf.ZilCSi;
	 Inc(Anz);
	 if Met < FBuf.ZilMet then Met:=FBuf.ZilMet;
	 Seek(F1,Adr);
	 BlockRead(F1,FBuf,64,Test);
       end;
       FTyp:=24;
       Kurz:='ZIP ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:=MetStr[Met];
     end;
end;

{************************************************************************}
{* Routine:     LzhInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr LZHs und ICEs          *}
{* Definition:  Procedure LzhInfo;                                      *}
{************************************************************************}

Procedure LzhInfo;
Var      GeSi,CoSi : Longint;
	 Adr       : Longint;
	 Anz       : Word;
begin
   if ((FBuf.LzhMet[1]='l') and (FBuf.LzhMet[2]='h')) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (FBuf.LzhHSi <> 0) do begin
	 Adr:=Adr+FBuf.LzhHSi+2+FBuf.LzhCSi;
	 GeSi:=GeSi+FBuf.LzhUSi;
	 CoSi:=CoSi+FBuf.LzhCSi;
	 Inc(Anz);
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,64,Test);
       end;
       FTyp:=24;
       Kurz:='LZH ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:='';
     end;
end;

{************************************************************************}
{* Routine:     ZooInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr ZOOs                   *}
{* Definition:  Procedure ZooInfo;                                      *}
{************************************************************************}

Procedure ZooInfo;
Const    MetStr    : Array[0..3] of TString=
		     ('Stored    ','ZOO Norm. ','ZOO High  ','Reserved  ');
Var      GeSi,CoSi : Longint;
	 Adr       : Longint;
	 Anz,Met   : Word;
begin
   if ((FBuf.ZooRe1[0]='Z') and (FBuf.ZooRe1[1]='O')) then
     with Dir[Count]^ do begin
       Adr:=FBuf.DummyA[$18];
       Seek(F1,Adr);
       Blockread(F1,FBuf,64,Test);
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       Met:=0;
       while ((FBuf.ZooKe1 <> 0) or (FBuf.ZooUSi <> 0)) do begin
	 Adr:=FBuf.ZooOfs;
	 GeSi:=GeSi+FBuf.ZooUSi;
	 CoSi:=CoSi+FBuf.ZooCSi;
	 Inc(Anz);
	 if Met < FBuf.ZooKe1 then Met:=FBuf.ZooKe1;
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,64,Test);
       end;
       FTyp:=24;
       Kurz:='ZOO ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:=MetStr[Met];
     end;
end;

{************************************************************************}
{* Routine:     SqzInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr SQZs                   *}
{* Definition:  Procedure SqzInfo;                                      *}
{************************************************************************}

Procedure SqzInfo;
Var      GeSi,CoSi : Longint;
	 Adr       : Longint;
	 Anz       : Word;
begin
   if (SFWord(0)=$484C) then
     with Dir[Count]^ do begin
       Adr:=8;
       Seek(F1,Adr);
       Blockread(F1,FBuf,64,Test);
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (FBuf.SqzTyp <> 0) do begin
	 if (FBuf.SqzTyp < 18) then 
	   if (FBuf.SqzTyp = 1) then Adr:=Adr+FBuf.SqzCCS+10
	   else Adr:=Adr+Fbuf.SqzCUS+3
	 else begin
	   Adr:=Adr+FBuf.SqzCSi+FBuf.SqzTyp+2;
	   GeSi:=GeSi+FBuf.SqzUSi;
	   CoSi:=CoSi+FBuf.SqzCSi;
	   Inc(Anz);
	 end;
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,64,Test);
       end;
       FTyp:=24;
       Kurz:='SQZ ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:='';
     end;
end;

{************************************************************************}
{* Routine:     RarInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr RARs                   *}
{* Definition:  Procedure RarInfo;                                      *}
{************************************************************************}

Procedure RarInfo;
Var      GeSi,CoSi : Longint;
	 Adr       : Longint;
	 Anz       : Word;
begin
   if (SFWord(0)=$5245) then
     with Dir[Count]^ do begin
       Adr:=FBuf.RarHLe;
       Seek(F1,Adr);
       Blockread(F1,FBuf,64,Test);
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (Adr<FileSize(F1)) do begin
	 Adr:=Adr+FBuf.RarCSi+FBuf.RarFLe;
	 if not((FBuf.RarAtt and $18)>0) then begin
	   GeSi:=GeSi+FBuf.RarUSi;
	   CoSi:=CoSi+FBuf.RarCSi;
	   Inc(Anz);
	 end;
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,64,Test);
       end;
       FTyp:=24;
       Kurz:='RAR ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:='';
     end
   else if (SFWord(0)=$5261) then
     with Dir[Count]^ do begin
       Adr:=FBuf.RanHLe;
       Seek(F1,Adr);
       Blockread(F1,FBuf,64,Test);
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (Adr<FileSize(F1)) do begin
	 Adr:=Adr+FBuf.RanHLe;
	 if (FBuf.RanFlg and $8000)=$8000 then Adr:=Adr+FBuf.RanCSi;
	 if (FBuf.RanTyp = $74) then begin
	   GeSi:=GeSi+FBuf.RanUSi;
	   CoSi:=CoSi+FBuf.RanCSi;
	   Inc(Anz);
	 end;
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,64,Test);
       end;
       FTyp:=24;
       Kurz:='RARn';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
       PTyp:='';
     end
end;

{************************************************************************}
{* Routine:     Gl1Info                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von PFil und PPro fr Grasp-GLs              *}
{* Definition:  Procedure Gl1Info;                                      *}
{************************************************************************}

Procedure Gl1Info;
begin
   if (FBuf.Gl1HSi mod 17)=0 then
     with Dir[Count]^ do begin
       FTyp:=24;
       Kurz:='GL  ';
       PFil:=(FBuf.Gl1HSi div 17) - 1;
       PPro:=0;
       PTyp:='Stored    ';
     end;
end;

{************************************************************************}
{* Routine:     T64Info                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von .T64 tape image files                    *}
{* Autor:       Peter Karlsson                                          *}
{* Definition:  Procedure T64Info;                                      *}
{************************************************************************}

Procedure T64Info;
begin
  If (Copy(FBuf.T64Ken, 1, 3) = 'C64') then
    with Dir[Count]^ do begin
      FTyp:=24;
      Kurz:='T64 ';
      If FBuf.T64Use = 0 then   { Anzahl von Dateien }
	PFil:=FBuf.T64Siz
      else
	PFil:=FBuf.T64Use;
      PPro:=0;
      PTyp:=Copy(TitStr(FBuf.T64Dsc)+'         ', 1, 10);
    end;
end;

{************************************************************************}
{* Routine:     D64Info                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von .D64 disk image files                    *}
{* Autor:       Peter Karlsson                                          *}
{* Definition:  Procedure D64Info;                                      *}
{************************************************************************}

Procedure D64Info;
Var
  fs, fp:               Longint;
  tr, se, zahlen, i:    Byte;
begin
  fs := FileSize(F1);
  If (fs = 174848) or (fs = 175531) or (fs = 196608) or (fs = 197376) then
    with Dir[Count]^ do begin
      Seek(F1, 91392); { Start of directory header block }
      Blockread(F1, FBuf.DummyA, 256, Test);
      If (FBuf.DummyA[0] = 18) and (FBuf.DummyA[1] = 1) and
	 (FBuf.DummyA[2] = 65) then { 18,01,65 = dir header block }
      begin
	Ftyp := 24;
	Kurz := 'D64 '; { 35 tracks }
	PPro:=0;
	If fs = 175531 then Kurz[4] := 'E'; { 35 tracks with error info }
	If fs = 196608 then Kurz[4] := '+'; { 40 tracks }
	If fs = 197375 then Kurz[4] := 'e'; { 40 tracks with error info }
	PTyp := '          ';
	i := 144; { offset fr Diskett-Name }
	While (i < 155) and (FBuf.Dummy0[i] <> #160) do begin
	  PTyp[i-143] := FBuf.Dummy0[i];
	  Inc(i);
	end;
	zahlen:= 0; { count dir entries }
	tr := 18; { dir start track }
	se := 1; { dir start sector }
	While tr = 18 do begin
	  Seek(F1, 91392 + se * 256);
	  Blockread(F1, FBuf.DummyA, 256, Test);
	  tr := FBuf.DummyA[0]; { nchste Spur }
	  se := FBuf.DummyA[1]; { nchste Sektor }
	  For i:=0 to 7 do
	    If (FBuf.DummyA[2+i*32] and $80) = $80 then { Datei-Entry }
	      Inc(zahlen);
	end;
	PFil := zahlen;
      end;
    end;
end;

{************************************************************************}
{* Routine:     PTextInfo                                               *}
{************************************************************************}
{* Inhalt:      Extraktion von                                          *}
{* Definition:  Procedure PTextInfo;                                    *}
{************************************************************************}

Procedure PTextInfo;
Var      Test      : Integer;
	 i         : Byte;
begin
   if (FileSize(F1)<250) then Test:=FileSize(F1)-1
   else Test:=250;
   while ((Test>=0) and (FBuf.DummyA[Test]>$06)) do Dec(Test);
   if (Test=-1) then
     with Dir[Count]^ do begin
       FTyp:=12;
       Kurz:='PTXT';
       TTit:='';
       if CFCompare(Addr(FBuf.Dummy0[0]),'%!PS-Adobe-') then begin
	 Kurz:='PS-x';
	 Kurz[4]:=FBuf.Dummy0[11];
	 i:=14;
	 while (i<=100) do begin
	   if FBuf.Dummy0[i]='%' then
	     if CFCompare(Addr(FBuf.Dummy0[i]),'%%Title:') then begin
	       inc(i,9);
	       while ((FBuf.Dummy0[i]<>chr(13)) and 
		      (FBuf.Dummy0[i]<>chr(10)) and (Length(TTit)<32)) do begin
		 TTit:=TTit+FBuf.Dummy0[i];
		 inc(i,1);
	       end;
	     end;
	   inc(i,1);
	 end;
       end;
       if UFCompare(Addr(FBuf.Dummy0[0]),'<HTML>') then begin
	 Kurz:='HTML';
	 i:=6;
	 while (i<=100) do begin
	   if UFCompare(Addr(FBuf.Dummy0[i]),'<TITLE>') then begin
	     inc(i,7);
	     while ((FBuf.Dummy0[i]<>'<') and (Length(TTit)<32)) do begin
	       if ((FBuf.Dummy0[i]<>chr(13)) and
		   (FBuf.Dummy0[i]<>chr(10))) then begin
		 TTit:=TTit+FBuf.Dummy0[i];
	       end;
	       inc(i,1);
	     end;
	     TTit:=OEMStr(TTit);
	   end;
	   inc(i,1);
	 end;
       end;
       if CFCompare(Addr(FBuf.Dummy0[0]),'{\rtf') then begin
	 Kurz:='RTF ';
	 for i:=5 to 100 do
	   if FBuf.Dummy0[i]='{' then
	     if CFCompare(Addr(FBuf.Dummy0[i]),'{\title') then begin
	       inc(i,8);
	       while (FBuf.Dummy0[i]<>'}') do begin
		 TTit:=TTit+FBuf.Dummy0[i];
		 inc(i,1);
	       end;
	     end;
       end;
       TTit:=TitStr(TTit);
     end;
end;

{************************************************************************}
{* Routine:     BtmInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von                                          *}
{* Autor:       Peter Karlsson                                          *}
{* Definition:  Procedure BtmInfo;                                      *}
{************************************************************************}

Procedure BtmInfo;
begin
  If (SFWord(0)=$EBBE) then begin
    with Dir[Count]^ do begin
      FTyp:=12;
      Kurz:='BTM ';
      TTit:='';
    end;
  end else
    PTextInfo;
end;

{************************************************************************}
{* Routine:     MsgInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von Information ber .MSG-Dateien und OS/2   *}
{*              Messagefiles                                            *}
{* Autor:       Peter Karlsson                                          *}
{* Definition:  Procedure MsgInfo;                                      *}
{************************************************************************}

Procedure MsgInfo;
Var      HStr      : String;
begin
  with Dir[Count]^ do begin
    If (FBuf.OMsKen = #255'MKMSGF'#0) then begin
      FTyp := 12;
      Kurz := 'OMSG';
      TTit := TitStr(FBuf.OMsIde);
    end
    else begin
      FTyp := 12;
      Kurz := 'MSG ';
      TTit := TitStr(FBuf.MsgSub);
    end;
  end;
end;

{************************************************************************}
{* Routine:     PktInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion der Quell-Nodenummer als Titel               *}
{* Definition:  Procedure PktInfo;                                      *}
{************************************************************************}

Procedure PktInfo;
Var      HStr      : String;
begin
   if (FBuf.PktPId=2) then
     with Dir[Count]^ do begin
       FTyp := 12;
       Kurz := 'PKT2';
       Str(FBuf.PktONo,HStr);
       TTit := '/'+HStr;
       Str(FBuf.PktONe,HStr);
       TTit := HStr+TTit;
       if (FBuf.PktCaW=Swap(FBuf.PktCaV)) then begin
	 Kurz[4] :='+';
	 Str(FBuf.PktOPt,HStr);
	 TTit := TTit+'.'+HStr;
	 Str(FBuf.PktOZo,HStr);
	 TTit := HStr+':'+TTit;
       end
       else begin
	 if (FBuf.PktOQZ<>0) then begin
	   Str(FBuf.PktOQZ,HStr);
	   TTit := HStr+':'+TTit;
	 end;
       end;
       TTit := TitStr(TTit);
     end;
end;

{************************************************************************}
{* Routine:     WordInfo                                                *}
{************************************************************************}
{* Inhalt:      Extraktion von                                          *}
{* Definition:  Procedure WordInfo;                                     *}
{************************************************************************}

Procedure WordInfo;
Var      Adr       : Longint;
	 i       : Word;
begin
   if (SFWord(0)=$31BE) then
     with Dir[Count]^ do begin
       FTyp:=12;
       TTit:='';
       if ((FBuf.DummyA[$60]<>0) and (FBuf.DummyA[$62]=0)) then Kurz:='WWRI'
       else begin
	 Kurz:='WORD';
	 Adr:=128*FWord($1C);
	 Seek(F1,Adr);
	 Blockread(F1,FBuf.DummyB,256,Test);
	 for i:=(FWord($100)+256) to (FWord($102)+255) do 
	   TTit:=TTit+FBuf.DummyB[i];
	 TTit:=TitStr(TTit);
       end;
     end
   else if (SFWord(0)=$32BE) then
     with Dir[Count]^ do begin
       FTyp:=12;
       TTit:='';
       Kurz:='WWRI'
     end
   else if (SFWord(0)=$9BA5) then
     with Dir[Count]^ do begin
       FTyp:=12;
       Kurz:='WfW1';
       Blockread(F1,FBuf.DummyB,64,Test);
       Adr := FWord($10C) + FWord($10E) * 65536 + 2;
       Write(Adr:14,':');
       Seek(F1,Adr);
       Blockread(F1,FBuf.DummyA,256,Test);
       Adr := FBuf.DummyA[0] + 1;
       Adr := Adr + FBuf.DummyA[Adr] + 1;
       Move(FBuf.Dummy0[Adr],TTit,Sizeof(TTit));
       TTit:=TitStr(OEMStr(TTit));
     end
   else if (SFWord(0)=$DBA5) then
     with Dir[Count]^ do begin
       FTyp:=12;
       TTit:='';
       Kurz:='WfW2';
       Blockread(F1,FBuf.DummyB,64,Test);
       Adr := FWord($118) + FWord($11A) * 65536 + 2;
       Seek(F1,Adr);
       Blockread(F1,FBuf.DummyA,256,Test);
       Adr := FBuf.DummyA[0] + 1;
       Adr := Adr + FBuf.DummyA[Adr] + 1;
       Move(FBuf.Dummy0[Adr],TTit,Sizeof(TTit));
       TTit:=TitStr(OEMStr(TTit));
     end
   else PTextInfo;
end;

{************************************************************************}
{* Routine:     HelpInfo                                                *}
{************************************************************************}
{* Inhalt:      Extraktion von                                          *}
{* Definition:  Procedure HelpInfo;                                     *}
{************************************************************************}

Procedure HelpInfo;
Const    WinHlpId  : Array[0..2] of Byte = ($3f,$5F,$03);
	 AdvHlpId  : Array[0..2] of Byte = ($4C,$4E,$02);
	 Os2HlpId  : Array[0..4] of Byte = ($48,$53,$50,$10,$9B);
	 Os2InfId  : Array[0..4] of Byte = ($48,$53,$50,$01,$9B);
Var      Adr       : Longint;
	 HAdr      : Byte;
	 P       : Boolean;
begin
   if BFCompare(Addr(FBuf),Addr(WinHlpId),2) then
     with Dir[Count]^ do begin
       FTyp:=13;
       Kurz:='WHLP';
       TTit:='';
       P:=False;
       Adr:=FBuf.DumLIn[1]+$37;
       Seek(F1,Adr);
       Blockread(F1,FBuf,256,Test);
       for HAdr:=0 to 240 do
	 if FBuf.Dummy0[HAdr] ='|' then begin
	   if CFCompare(Addr(FBuf.Dummy0[HAdr+1]),'CONTEXT') then Kurz:='WH31';
	   if CFCompare(Addr(FBuf.Dummy0[HAdr+1]),'TOMAP') then Kurz:='WH30';
	   if CFCompare(Addr(FBuf.Dummy0[HAdr+1]),'SYSTEM') then begin
	     Adr:=FWord(HAdr+8) + FBuf.DummyA[HAdr+10]*65536 + $15;
	     P:=True;
	   end;
	 end;
       if P then begin
	 if Kurz='WH31' then Inc(Adr,4);
	 Seek(F1,Adr);
	 Blockread(F1,FBuf,256,Test);
	 for HAdr:=0 to 31 do TTit:=TTit+FBuf.Dummy0[HAdr];
	 TTit:=TitStr(OEMStr(TTit));
       end;
     end
   else if BFCompare(Addr(FBuf),Addr(AdvHlpId),2) then
     with Dir[Count]^ do begin
       FTyp:=13;
       Kurz:='AHLP';
       TTit:='';
       for HAdr:=16 to 47 do TTit:=TTit+FBuf.Dummy0[HAdr];
       TTit:=TitStr(TTit);
     end
   else if BFCompare(Addr(FBuf),Addr(Os2HlpId),4) then
     with Dir[Count]^ do begin
       FTyp:=13;
       Kurz:='OHLP';
       TTit:='';
       for HAdr:=$6B to $7F do TTit:=TTit+FBuf.Dummy0[HAdr];
       TTit:=TitStr(TTit);
     end
   else if BFCompare(Addr(FBuf),Addr(Os2InfId),4) then
     with Dir[Count]^ do begin
       FTyp:=13;
       Kurz:='OINF';
       TTit:='';
       for HAdr:=$6B to $7F do TTit:=TTit+FBuf.Dummy0[HAdr];
       TTit:=TitStr(TTit);
     end
   else PTextInfo;
end;

{************************************************************************}
{* Routine:     GetInfo                                                 *}
{************************************************************************}
{* Inhalt:      Auswahl der Info-Routine anhand der File-Extension      *}
{* Definition:  Procedure GetInfo;                                      *}
{************************************************************************}

Procedure GetInfo;
Var      P,Test    : Integer;
	 E       : String[3];
begin
   with Dir[Count]^ do begin
     P := Pos('.', Name);
     if P > 1 then E := Copy(Name, P + 1, 3)
     else E := '';
     if (Attr and (Directory)) = 0 then begin   {Modifikat. F.Decker}
       if PrntT then Write(Name:8);
       Assign(F1,D+Name);
       Reset(F1,1);
       Test:=IOResult;
       if (Test=5) or (Test=162) then begin
	 Filemode:=64;
	 Reset(F1,1);
	 Test:=IOResult;
	 Filemode:=0;
       end;
       if Test=0 then begin
	 BlockRead(F1,FBuf,256,Test);
	 if PrntT then Write('...read');

	 if E = 'GIF' then GifInfo;

	 if E = 'PCX' then PcxInfo;

	 if E = 'DCX' then DcxInfo;

	 if ((E = 'BMP') or (E = 'DIB')) then BmpInfo;

	 if ((E = 'ICO') or (E = 'ICW') or (E = 'IC2') or 
	     (E = 'CUR') or (E = 'PTR')) then 
	   IcoInfo;

	 if E = 'RLE' then RleInfo;

	 if E = 'RIF' then RDibInfo;

	 if ((E = 'LBM') or (E ='IFF') or (E = 'BBM')) then LbmInfo;

	 if (E = 'IMG') then ImgInfo;

	 if ((E = 'JPG') or (E = 'JIF')) then JpgInfo;

	 if E = 'MSP' then MspInfo;

	 if ((Copy(E,1,2) = 'SC') or (E = 'RIX') or (E ='VMG')) then SciInfo;

	 if ((E = 'FLI') or (E = 'FLC')) then FliInfo;

	 if E = 'AVI' then AviInfo;

	 if E = 'MOV' then MovInfo;

	 if E = 'ANI' then AniInfo;

	 if E = 'CUT' then CutInfo;

	 if E = 'PIC' then PicInfo;

	 if E = 'TGA' then TgaInfo;

	 if E = 'PNG' then PngInfo;

	 if E = 'RAS' then RasInfo;

	 if E = 'WPG' then WpgInfo;

	 if E = 'TIF' then TiffInfo;

	 if ((E = 'MAC') or (E = 'PNT')) then
	   MacInfo;

	 if ((E = 'DBF') or (E = 'DBK') or (E = 'CAT')) then DbfInfo;

	 if ((E = 'WKS') or (E = 'WK1') or (E = 'WQ1') or
	     (E = 'WQ2')) then WksInfo;

	 if ((E = 'EXE') or (E = 'DLL') or (E = 'DRV') or 
	     (E = 'FON') or (E = 'FOT') or (E = '386') or
	     (E = 'ADD') or (E = 'IFS') or (E = 'VBX') or
	     (E = 'CPL') or (E = 'VXD') or (E = 'FLT') or
	     (E = 'DMD') or (E = 'QTC')) then
	   ExeInfo;

	 if (FTyp = 0) and (E = 'SCR') then ExeInfo;

	 if E = 'COM' then ComInfo;

	 if ((E = 'NLM') or (E = 'DSK')) then
	   NlmInfo;

	 if E = 'VAP' then VapInfo;

	 if ((E = 'SYS') or (E = 'DOS')) then DevInfo;

	 if E = 'GRP' then GroupInfo;

	 if ((E = 'PIF') or (E = 'DVP')) then
	   PifInfo;

	 if ((E = 'TPU') or (E = 'TPW') or (E = 'TPP')) then
	   TpuInfo;

	 if E = 'OBJ' then OBJInfo;

	 if E = 'TTF' then TTFInfo;

	 if E = 'PFB' then PfbInfo;

	 if E = 'PFM' then PfmInfo;

	 if E = 'CMF' then CmfInfo;

	 if E = 'CMS' then CmsInfo;

	 if E = 'ORG' then OrgInfo;

	 if E = 'MOD' then ModInfo;

	 if E = '669' then G69Info;

	 if E = 'S3M' then S3MInfo;

	 if E = 'ROL' then RolInfo;

	 if E = 'WAV' then WavInfo;

	 if E = 'VOC' then VocInfo;

	 if E = 'AU' then AUInfo;

	 if ((E = 'SND') or (E = 'TUN') or (E = 'AIF')) then
	   SndInfo;

	 if E = 'MID' then MidiInfo;

	 if ((E = 'TXT') or (E = 'WRI') or (E = 'DOC')) then
	   WordInfo;

	 if ((E = 'HLP') or (E = 'INF')) then HelpInfo;

	 if ((E = 'ASM') or (E = 'PAS') or (E = 'CPP') or 
	     (E = 'LST') or (E = 'BAT') or (E = 'INI') or
	     (E = 'RTF') or (E = 'DOC') or (E = 'INC') or
	     (E = 'MAK') or (E = 'RC2') or (E = 'DLG') or
	     (E = 'CMD') or (E = 'DIZ') or (E = 'HTM') or
	     (E = 'RC') or (E = 'PS') or (E = 'C') or (E = 'H')) then
	   PTextInfo;

	 if E = 'ARJ' then ArjInfo;

	 if E = 'ZIP' then ZipInfo;

	 if ((E = 'ARC') or (E = 'PAK') or (E = 'SDN')) then ArcInfo;

	 if ((E = 'LZH') or (E = 'ICE')) then LzhInfo;

	 if E = 'ZOO' then ZooInfo;

	 if E = 'SQZ' then SqzInfo;

	 if E = 'RAR' then RarInfo;

	 if E = 'GL' then Gl1Info;

	 if E = 'PKT' then PktInfo;

	 if E = 'MSG' then MsgInfo; {Mod. P.Karlsson}

	 if E = 'T64' then T64Info; {Mod. P.Karlsson}

	 if E = 'D64' then D64Info; {Mod. P.Karlsson}

	 if E = 'BTM' then BtmInfo; {Mod. P.Karlsson}

	 if (SSearch and (FTyp = 0)) then ExeInfo;
	 if (SSearch and (FTyp = 0)) then PTextInfo;

	 Close(F1);  {Mod. F.Decker}
	 if (IOResult<>0) and PrntT then Write('...IOError');
	 if PrntT then Writeln('...OK!');
       end
     end;
   end;
end;

{************************************************************************}
{* Routine:     Hauptprogramm                                           *}
{************************************************************************}
{* Inhalt:      - (keine Vorinitialisierung notwendig)                  *}
{************************************************************************}

begin
end.
