{************************************************************************}
{* Include:     AD_Appli.Inc                                            *}
{************************************************************************}
{* Inhalt:      Apllikations-Routinen fr Modul ADInfo.Pas              *}
{************************************************************************}
{* Version:     0.58e   (ADIR)                                          *}
{* Autor:       Thomas Mainka                                           *}
{* Datum:       14.Nov.1996                                             *}
{************************************************************************}

{************************************************************************}
{* Routine:     DevTest                                                 *}
{************************************************************************}
{* Inhalt:      Test auf DOS-Device-Treiber und Ermittelung der         *}
{*              Treibernamen                                            *}
{* Definition:  Function DevTest(Adr1:Longint):String                   *}
{************************************************************************}

Function DevTest(Adr1:Longint):String;
Var      Adr       : Longint;
         HStr      : String;
         TOfs      : Word;
begin
   HStr:='';
   Adr:=Adr1;
   TOfs:=0;
   Seek(F1,Adr);
   BlockRead(F1,FBuf,32,Test);
   Adr:=Adr1+FBuf.DevLOf;
   while((FBuf.DevLOf<>$ffff) and (Adr < FileSize(F1)) and 
         ((FBuf.DevLSe=$0000) or (FBuf.DevLSe>=FBuf.DevLOf)) and
         (TOfs+16 < FBuf.DevLOf)) do begin
     TOfs:=FBuf.DevLOf;
     if (FBuf.DevAtt and $8000)=$8000 then HStr:=HStr+FBuf.DevNam+'|'
     else HStr:=HStr+NumStr(Ord(FBuf.DevNam[1]),2)+StrDevDri;
     Seek(F1,Adr);
     BlockRead(F1,FBuf,32,Test);
     Adr:=Adr1+FBuf.DevLOf;
   end;
   if ((FBuf.DevLOf=$ffff) and (FBuf.DevLSe=$ffff)) then begin
     if (FBuf.DevAtt and $8000)=$8000 then HStr:=HStr+FBuf.DevNam+'|'
     else HStr:=HStr+NumStr(Ord(FBuf.DevNam[1]),2)+StrDevDri;
     DevTest:=HStr;
   end
   else DevTest:='';
end;

{************************************************************************}
{* Routine:     SearchCoffVers                                          *}
{************************************************************************}
{* Inhalt:      Suche des Applikationsnamens aus der Versiononsinfo     *}
{*              fr Win32-EXE-Dateien                                   *}
{* Definition:  Function SearchCoffVers(Var Adr:Longint):String         *}
{************************************************************************}

Function SearchCoffVers(Var Adr:Longint):String;
Const    CStr1     : Array[0..4] of Byte = ($34,$00,$00,$00,$56);
         CStr2     : Array[0..11] of Byte
                       = ($46,$00,$69,$00,$6c,$00,$65,$00,$44,$00,$65,$00);
Var      i,j,l     : Integer;
         HStr      : String;
begin
   HStr:='';
   for i:=0 to 1000 do
     if BFCompare (Addr(FBuf.DummyA[i]),Addr(CStr1),4) then begin
       for j:=i to 1400 do
         if BFCompare (Addr(FBuf.DummyA[j]),Addr(CStr2),11) then begin
           for l:=0 to 31 do
             HStr:= HStr + Char(FBuf.DummyA[j+2*l+34]);
           j:=1400;
         end;
       i:=1000;
     end;
   SearchCoffVers:=HStr;
end;

{************************************************************************}
{* Routine:     ExeInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von Betriebsysten, ETit, EFlg und EVer fr   *}
{*              DOS-, WIN und OS/2-EXE-Dateien (incl. Treiber+DLLs)     *}
{* Definition:  Procedure ExeInfo;                                      *}
{************************************************************************}

Procedure ExeInfo;
Var      HStr      : String;
         MaxLen,i,j: Byte;
         Adr       : Longint;

begin
   if (FBuf.ExeKen = $5A4D) then
     with Dir[Count]^ do begin
       FTyp:=20;
       Kurz:='DOS ';
       ETit:='';
       EFlg:=0;
       EVer:=0;
       if (WideText) then MaxLen:=32
       else MaxLen:=20;
       if (FBuf.ExeSRe = 64) then begin
         Adr:=FBuf.ExeAdN;
         Seek(F1,FBuf.ExeAdN);
         BlockRead(F1,FBuf,256,Test);
         if (FBuf.ExnKen=$454E) then begin
           if (FBuf.ExnFl2 = 2) then begin
             Kurz:='WIN ';
             EVer:=FBuf.ExnVer;
           end
           else if (FBuf.ExnFl2 = 1) then
             if (FBuf.ExnFl1 and $0800)=$0800 then Kurz:='FAPI'
             else if (FBuf.ExnFl1 and $0300)=$0300 then Kurz:='PM/2'
             else Kurz:='OS/2'
           else if (FBuf.ExnFl2 = 5) then
             Kurz:='BOSS'
           else Kurz[4]:='?';
           EFlg:=FBuf.ExnFl3;
           if FBuf.ExnONN > FileSize(F1) then Seek(F1,Word(FBuf.ExnONN))
           else Seek(F1,FBuf.ExnONN);
           Blockread(F1,FBuf,256,Test);
           HStr:=FBuf.DumStr;
           if (Pos('Microsoft',HStr)<>0) and (Length(HStr)>MaxLen) then begin
             Test:=Pos('Microsoft',HStr);
             HStr:=Copy(HStr,1,Test-1) + 'MS' +
                   Copy(HStr,Test+9,Length(HStr)-Test-8);
           end;
           if (Pos('FONTRES',HStr)<>0) and (Length(HStr)>MaxLen) then begin
             Test:=Pos(':',HStr);
             HStr:='FNT:' + Copy(HStr,Test+1,Length(HStr)-Test);
           end;
           if (Pos('@#',HStr)<>0) and (Pos('#@',HStr)<>0) and
              (Length(HStr)>MaxLen) then begin
             Test:=Pos('#@',HStr)+3;
             HStr:=Copy(HStr,1,Pos('@#',HStr)-1) +
                   Copy(HStr,Test,Length(HStr)-Test);
           end;
           ETit:=Copy(HStr,1,32);
         end
         else if (FBuf.ExnKen=$454C) then begin
           Kurz:='W386';
           EVer:=FBuf.ExlVer;
           Seek(F1,FBuf.ExlONN);
           Blockread(F1,FBuf,256,Test);
           HStr:=FBuf.DumStr;
           if (Pos('Microsoft',HStr)<>0) and (Length(HStr)>MaxLen) then begin
             Test:=Pos('Microsoft',HStr);
             HStr:=Copy(HStr,1,Test-1) + 'MS' +
                   Copy(HStr,Test+9,Length(HStr)-Test-8);
           end;
           ETit:=Copy(HStr,1,32);
         end
         else if (FBuf.ExnKen=$584C) then begin
           if (FBuf.ExlMoT and $0300)=$0300 then Kurz:='PM2L'
           else Kurz:='OS2L';
           if FBuf.ExlONN<>0 then begin
             Seek(F1,FBuf.ExlONN);
             Blockread(F1,FBuf,256,Test);
             HStr:=FBuf.DumStr;
             if (Pos('Presentation Manager',HStr)<>0) and 
                (Length(HStr)>MaxLen) then begin
               Test:=Pos('Presentation Manager',HStr);
               HStr:=Copy(HStr,1,Test-1) + 'PM' +
                     Copy(HStr,Test+20,Length(HStr)-Test-19);
             end;
             if (Pos('Application',HStr)<>0) and 
                (Length(HStr)>MaxLen) then begin
               Test:=Pos('Application',HStr);
               HStr:=Copy(HStr,1,Test-1) + 'App.' +
                     Copy(HStr,Test+11,Length(HStr)-Test-10);
             end;
             if (Pos('@#',HStr)<>0) and (Pos('#@',HStr)<>0) and
                (Length(HStr)>MaxLen) then begin
               Test:=Pos('#@',HStr)+3;
               HStr:=Copy(HStr,1,Pos('@#',HStr)-1) +
                     Copy(HStr,Test,Length(HStr)-Test);
             end;
             ETit:=Copy(HStr,1,32);
           end;
         end
         else if (FBuf.ExnKen=$4550) then begin
           Kurz:='COFF';
           j:=FBuf.CofAnz;
           Seek(F1,Adr+FBuf.CofOfs+24);
           BlockRead(F1,FBuf.DummyB,512,Test);
           for i:=1 to j do begin
             if CFCompare (Addr(FBuf.CofEnt [i]),'.rsrc') then begin
               Adr:=FBuf.CofEnt[i].Pos;
               i:=j;
               Seek(F1,Adr);
               BlockRead(F1,FBuf,1536,Test);
               ETit:=OEMStr(SearchCoffVers(Adr));
             end;
           end;
         end
       end
       else begin
         HStr:=Copy(DevTest(FBuf.ExeGHe*16),1,MaxLen);
         if HStr<>'' then begin
           Kurz:='DDEV';
           if Length(HStr)=MaxLen then begin
             HStr[MaxLen-1]:='.';
             HStr[MaxLen]  :='.';
           end
           else HStr[Length(HStr)]:=' ';
           ETit:=HStr;
         end;
       end;
       if Kurz[1]='W' then ETit:=OEMStr(ETit);
       ETit:=TitStr(ETit);
     end;
end;

{************************************************************************}
{* Routine:     ComInfo                                                 *}
{************************************************************************}
{* Inhalt:      Test auf verstecktes EXE und Identifikation als COM-Dat.*}
{* Definition:  Procedure ComInfo;                                      *}
{************************************************************************}

Procedure ComInfo;
begin
   if (FBuf.ExeKen=$5A4D) then ExeInfo
   else  
     with Dir[Count]^ do begin
       FTyp:=20;
       if (FBuf.DummyA [0]=$C3) then Kurz:='CP/M'
       else                          Kurz:='COM ';
       ETit:='';
       EFlg:=0;
       EVer:=0;
     end;
end;

{************************************************************************}
{* Routine:     PifInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion des Applikations-Namens aus Win- und DV-PIFs.*}
{* Definition:  Procedure PifInfo;                                      *}
{************************************************************************}

Procedure PifInfo;
Var      PifL,i    : Word;
begin
   with Dir[Count]^ do begin
     Kurz:='';
     PifL:=FileSize(F1);
     if ((PifL > 256) and (PifL < 1024)) then
       BlockRead(F1,FBuf.DummyB,PifL-256,Test);
     if ((PifL=369) and (FWord(367)=$60e0)) then 
       Kurz:='PIF2';
     if ((PifL=545) and (FWord(369)=$494d)) then
       Kurz:='PIF3';
     if (PifL=416) then Kurz:='DVP ';
     if (PifL>620) then begin
       i:=512;
       while (i<600) do begin
         if CFCompare(Addr(FBuf.Dummy0[i]),'WINDOWS VMM 4') then begin
           Kurz:='PIF4';
           i:=600;
         end;
         inc(i,1);
       end;
     end;

     if (Kurz<>'') then begin
       FTyp:=21;
       ETit:='';
       EFlg:=0;
       EVer:=0;
       for Test:=2 to 32 do ETit:=ETit+FBuf.Dummy0[Test];
       if Kurz[4]='3' then ETit:=OEMStr(ETit);
       ETit:=TitStr(ETit);
     end;
   end;
end;

{************************************************************************}
{* Routine:     NlmInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Novell ladbare Module           *}
{* Definition:  Procedure NlmInfo;                                      *}
{************************************************************************}

Procedure NlmInfo;
begin
   if (FBuf.NlmKen='NetWare Loadable Module') then
     with Dir[Count]^ do begin
       FTyp:=20;
       Kurz:='NLM ';
       ETit:=Copy(FBuf.NlmNam,1,32);
       ETit:=TitStr(ETit);
       EFlg:=0;
       EVer:=0;
     end;
end;

{************************************************************************}
{* Routine:     VapInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Novell VAPs                     *}
{* Definition:  Procedure VapInfo;                                      *}
{************************************************************************}

Procedure VapInfo;
Var      Adr       : Longint;
begin
   if (FBuf.ExeKen=$5A4D) then begin
     Adr:=FBuf.ExeGHe*16;
     Seek(F1,Adr);
     BlockRead(F1,FBuf,256,Test);
     if (FBuf.VapKen='NWProc') then
       with Dir[Count]^ do begin
         FTyp:=20;
         Kurz:='VAP ';
         ETit:='';
         while ((Length(ETit)<32) and (Ord(FBuf.VapInf[Length(ETit)])>=$20)) do 
           ETit:=ETit+FBuf.VapInf[Length(ETit)];
         ETit:=TitStr(ETit);
         EFlg:=0;
         EVer:=0;
       end;
   end;
end;

{************************************************************************}
{* Routine:     DevInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Dos-Devicetreiber               *}
{* Definition:  Procedure DevInfo;                                      *}
{************************************************************************}

Procedure DevInfo;
Var      HStr      : String;
         MaxLen    : Byte;
begin
   if (FBuf.ExeKen=$5A4D) then ExeInfo
   else begin
     HStr:=Copy(Devtest(0),1,32);
     if HStr<>'' then
       with Dir[Count]^ do begin
         FTyp:=20;
         Kurz:='DDEV';
         if (WideText) then MaxLen:=32
         else MaxLen:=20;
         if Length(HStr)=MaxLen then begin
           HStr[MaxLen-1]:='.';
           HStr[MaxLen]  :='.';
         end
         else HStr[Length(HStr)]:=' ';
         ETit:=TitStr(Copy(HStr,1,32));
         EFlg:=0;
         EVer:=0;
       end;
   end;
end;

{************************************************************************}
{* Routine:     GroupInfo                                               *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr WinGroups                       *}
{* Definition:  Procedure GroupInfo;                                    *}
{************************************************************************}

Procedure GroupInfo;
Const    WinGrpId  : Array[0..2] of Byte = ($50,$4D,$43);
Var      Adr       : Longint;
         HStr      : String;
begin
   if BFCompare(Addr(FBuf),Addr(WinGrpId),2) then
     with Dir[Count]^ do begin
       FTyp:=21;
       Kurz:='WGRP';
       ETit:='';
       Adr:=FWord($16);
       Seek(F1,Adr);
       Blockread(F1,FBuf,32,Test);
       for Adr:=0 to 31 do ETit:=ETit+FBuf.Dummy0[Adr];
       ETit:=TitStr(OEMStr(ETit));
       EFlg:=0;
       EVer:=0;
     end;
end;

{************************************************************************}
{* Routine:     TpuInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Turbo-Pascal-TPUs               *}
{* Definition:  Procedure TpuInfo;                                      *}
{************************************************************************}

Procedure TpuInfo;
Var      Adr       : Longint;
begin
   if CFCompare(Addr(FBuf),'TPU') then
     with Dir[Count]^ do begin
       FTyp:=22;
       Kurz:='TPU ';
       if FBuf.Dummy0[3]='5' then Kurz[4]:='5';
       if FBuf.Dummy0[3]='6' then begin 
         Kurz[3]:='5';
         Kurz[4]:='5';
       end;
       if FBuf.Dummy0[3]='9' then Kurz[4]:='6';
       if FBuf.Dummy0[3]='Q' then Kurz[4]:='7';
       ETit:='';
       Adr:=FWord(8)+3;
       if FBuf.DummyA[3]< $36 then Dec(Adr,1);
       Seek(F1,Adr);
       BlockRead(F1,FBuf.DummyA,64,Test);
       ETit:=TitStr(FBuf.DumStr);
       EFlg:=0;
       EVer:=0;
     end;
end;

{************************************************************************}
{* Routine:     ObjInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Intel-OBJs                      *}
{* Definition:  Procedure ObjInfo;                                      *}
{************************************************************************}

Procedure ObjInfo;
begin
   if (FBuf.ObjKen = $80) then
     with Dir[Count]^ do begin
       FTyp:=22;
       Kurz:='OBJ ';
       ETit:=TitStr(FBuf.ObjNam);
       EFlg:=0;
       EVer:=0;
     end;
end;

{************************************************************************}
{* Routine:     TTFInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Truetype TTF-Fontdateien        *}
{* Definition:  Procedure TTFInfo;                                      *}
{************************************************************************}

Procedure TTFInfo;
Var      Adr,Len   : Longint;
         i,j       : Byte;
begin
   if FBuf.TTFVer = $00000100 then begin
     Adr:=0;
     if Swap(FBuf.TTFTab)>15 then
       Blockread(F1,FBuf.DummyB,128,Test);
     for i:=0 to Swap(FBuf.TTFTab) do
       if FBuf.TTFTag[i].Tag='name' then begin
         Adr:=LongI(FBuf.TTFTag[i].Adr);
         Len:=LongI(FBuf.TTFTag[i].Len);
         if Len > 4000 then Len:=4000;
       end;
     if Adr>0 then
       with Dir[Count]^ do begin
         FTyp := 23;
         Kurz := 'TTF ';
         ETit := '';
         Seek(F1,Adr);
         BlockRead(F1,FBuf.DummyA,Len,Test);
         for i:=0 to Swap(FBuf.TTFNum)-1 do
           with FBuf.TTFRec[i] do begin
             if ((Swap(PId)=1) and (Swap(NId)=4)) then begin
               j:=0;
               while ((j<32) and (j<Swap(Len))) do begin
                 ETit:=ETit+FBuf.Dummy0[Swap(FBuf.TTFOfs)+Swap(Ofs)+j];
                 inc(j);
               end; 
               i:=Swap(FBuf.TTFNum)-1;
             end;
           end;
         ETit:=TitStr(OEMStr(ETit));
         EFlg:=0;
         EVer:=0;
       end;
   end;
end;

{************************************************************************}
{* Routine:     PfbInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Postscript PFB-Fontdateien      *}
{* Definition:  Procedure PfbInfo;                                      *}
{************************************************************************}

Procedure PfbInfo;
Var      i,j       : Byte;
begin
   if (CFCompare(Addr(FBuf.Dummy0[6]),'%!PS-AdobeFont')) or
      (CFCompare(Addr(FBuf.Dummy0[6]),'%!FontType1')) then
     with Dir[Count]^ do begin
       FTyp:=23;
       Kurz:='PFB ';
       ETit:='';
       for i:=15 to 25 do
       if FBuf.Dummy0[i]=':' then begin
         j:=i+2;
         while (Length(ETit)<32) and (FBuf.Dummy0[j]<>' ') do begin
           ETit:=ETit+FBuf.Dummy0[j];
           Inc(j,1);
         end;
       end;
       ETit:=TitStr(ETit);
       EFlg:=0;
       EVer:=0;
     end;
end;

{************************************************************************}
{* Routine:     PfmInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von ETit fr Postscript PFM-Fontdateien      *}
{* Definition:  Procedure PfmInfo;                                      *}
{************************************************************************}

Procedure PfmInfo;
Var      i,j       : Byte;
begin
   if (CFCompare(Addr(FBuf.Dummy0[$c7]),'PostScript')) then
     with Dir[Count]^ do begin
       FTyp:=23;
       Kurz:='PFM ';
       ETit:=TitStr('');
       move (FBuf.Dummy0[$d2],ETit[1],32);
       ETit:=TitStr(ETit);
       EFlg:=0;
       EVer:=0;
     end;
end;

